Split code out into separate files and remove some global variables to
[rsync/rsync.git] / runtests.sh
index c55f9cc..d2865ae 100755 (executable)
@@ -1,6 +1,6 @@
 #! /bin/sh
 
-# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
+# Copyright (C) 2001, 2002 by Martin Pool <mbp@samba.org>
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License version
 # You cannot use "function foo {" syntax, but must instead say "foo()
 # {", or it breaks on FreeBSD.
 
+# BSD machines tend not to have "head" or "seq".
+
+# You cannot do "export VAR=VALUE" all on one line; the export must be
+# separate from the assignment.  (SCO SysV)
+
 
 
 # STILL TO DO:
 # Perhaps we need a common way to cleanup tests.  At the moment just
 # clobbering the directory when we're done should be enough.
 
+# If any of the targets fail, then (GNU?) Make returns 2, instead of
+# the return code from the failing command.  This is fine, but it
+# means that the build farm just shows "2" for failed tests, not the
+# number of tests that actually failed.  For more details we might
+# need to grovel through the log files to find a line saying how many
+# failed.
+
 
 set -e
 
@@ -113,6 +125,9 @@ set -e
 
 RUNSHFLAGS='-e'
 
+# for Solaris
+PATH="/usr/xpg4/bin/:$PATH"
+
 if [ -n "$loglevel" ] && [ "$loglevel" -gt 8 ]
 then
     if set -x
@@ -127,6 +142,20 @@ echo "$0 running in `pwd`"
 echo "    rsync_bin=$rsync_bin"
 echo "    srcdir=$srcdir"
 
+testuser=`whoami || echo UNKNOWN`
+
+echo "    testuser=$testuser"
+echo "    os=`uname -a`"
+
+# It must be "yes", not just nonnull
+if test "x$preserve_scratch" = xyes
+then
+    echo "    preserve_scratch=yes"
+else
+    echo "    preserve_scratch=no"
+fi    
+
+
 if test ! -f $rsync_bin
 then
     echo "rsync_bin $rsync_bin is not a file" >&2
@@ -148,16 +177,27 @@ missing=0
 passed=0
 failed=0
 
-scratchdir=./testtmp
-[ -d "$scratchdir" ] && rm -r "$scratchdir"
-mkdir "$scratchdir"
-scratchdir=`cd $scratchdir && pwd`
-echo "    scratchdir=$scratchdir"
+# Prefix for scratch directory.  We create separate directories for
+# each test case, so that they can be left behind in case of failure
+# to aid investigation.
+scratchbase="`pwd`"/testtmp
+echo "    scratchbase=$scratchbase"
 
 suitedir="$srcdir/testsuite"
 
 export scratchdir suitedir
 
+prep_scratch() {
+    [ -d "$scratchdir" ] && rm -rf "$scratchdir"
+    mkdir "$scratchdir"
+    return 0
+}
+
+maybe_discard_scratch() {
+    [ x"$preserve_scratch" != xyes ] && [ -d "$scratchdir" ] && rm -rf "$scratchdir"
+    return 0
+}
+
 if [ "x$whichtests" = x ]
 then
     whichtests="*.test"
@@ -165,29 +205,50 @@ fi
 
 for testscript in $suitedir/$whichtests
 do
-    testbase=`echo $testscript | sed 's!.*/!!'`
+    testbase=`echo $testscript | sed 's!.*/!!' | sed -e 's/.test\$//'`
+    scratchdir="$scratchbase.$testbase"
+
+    prep_scratch
 
-    echo "----- $testbase starting"
+    set +e
+    sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1
+    result=$?
+    set -e
 
-    if sh $RUNSHFLAGS "$testscript"
+    if [ "x$always_log" = xyes -o \( $result != 0 -a $result != 77 -a $result != 78 \) ]
     then
-       echo "----- $testbase completed succesfully"
-       passed=`expr $passed + 1`
-    else 
-       case $? in
-       77)
-           echo "----- $testbase skipped"
-           skipped=`expr $skipped + 1`
-           ;;
-       *)
-           echo "----- $testbase failed!"
-           failed=`expr $failed + 1`
-           if [ "x$nopersist" = "xyes" ]
-           then
-               exit 1
-           fi
-       esac
+       echo "----- $testbase log follows"
+       cat "$scratchdir/test.log"
+       echo "----- $testbase log ends"
     fi
+
+    case $result in
+    0)
+       echo "PASS    $testbase"
+       passed=`expr $passed + 1`
+       maybe_discard_scratch
+       ;;
+    77)
+       # backticks will fill the whole file onto one line, which is a feature
+       echo "SKIP    $testbase (`cat \"$scratchdir/whyskipped\"`)"
+       skipped=`expr $skipped + 1`
+       maybe_discard_scratch
+       ;;
+    78)
+        # It failed, but we expected that.  don't dump out error logs, 
+       # because most users won't want to see them.  But do leave
+       # the working directory around.
+       echo "XFAIL   $testbase"
+       failed=`expr $failed + 1`
+       ;;
+    *)
+       echo "FAIL    $testbase"
+       failed=`expr $failed + 1`
+       if [ "x$nopersist" = "xyes" ]
+       then
+           exit 1
+       fi
+    esac
 done
 
 echo '------------------------------------------------------------'
@@ -198,4 +259,11 @@ echo "      $passed passed"
 [ "$missing" -gt 0 ] && echo "      $missing missing"
 echo '------------------------------------------------------------'
 
-exit `expr $failed + $missing`
+# OK, so expr exits with 0 if the result is neither null nor zero; and
+# 1 if the expression is null or zero.  This is the opposite of what
+# we want, and if we just call expr then this script will always fail,
+# because -e is set.
+
+result=`expr $failed + $missing || true`
+echo "overall result is $result"
+exit $result